# insert_iterator Class Template Reference

Inheritance diagram for insert_iterator:

List of all members.

## Detailed Description

### template<typename _Container>
class std::insert_iterator< _Container >

These are output iterators, constructed from a container-of-T. Assigning a T to the iterator inserts it in the container at the iterator's position, rather than overwriting the value at that position.

(Sequences will actually insert a copy of the value before the iterator's position.)

Tip: Using the inserter function to create these iterators can save typing.

Definition at line 489 of file stl_iterator.h.

## Public Types

- typedef _Container container_type
- typedef void difference_type
- typedef output_iterator_tag iterator_category
- typedef void pointer
- typedef void reference
- typedef void value_type

## Public Member Functions

- insert_iterator (_Container &__x, typename _Container::iterator __i)
- insert_iterator & operator * ()
- insert_iterator & operator++ (int)
- insert_iterator & operator++ ()
- insert_iterator & operator= (const typename _Container::const_reference __value)

## Protected Attributes

- _Container * container
- _Container::iterator iter

## Member Typedef Documentation

typedef _Container container_type

| A nested typedef for the type of whatever container you used. Definition at line 498 of file stl_iterator.h.

typedef void difference_type `[inherited]`

| Distance between iterators is represented as this type. Definition at line 113 of file stl_iterator_base_types.h.

typedef output_iterator_tag iterator_category `[inherited]`

| One of the tag types. Definition at line 109 of file stl_iterator_base_types.h.

typedef void pointer `[inherited]`

| This type represents a pointer-to-value_type. Definition at line 115 of file stl_iterator_base_types.h.

typedef void reference `[inherited]`

| This type represents a reference-to-value_type. Definition at line 117 of file stl_iterator_base_types.h.

typedef void value_type `[inherited]`

| The type "pointed to" by the iterator. Definition at line 111 of file stl_iterator_base_types.h.

## Constructor & Destructor Documentation

insert_iterator | ( | _Container & | __x,
|  | typename _Container::iterator | __i
| ) | `[inline]`

| The only way to create this iterator is with a container and an initial position (a normal iterator into the container). Definition at line 504 of file stl_iterator.h.

## Member Function Documentation

insert_iterator& operator * | ( |  | ) | `[inline]`

| Simply returns *this. Definition at line 540 of file stl_iterator.h.

insert_iterator& operator++ | ( | int |  | ) | `[inline]`

| Simply returns *this. (This iterator does not "move".). Definition at line 550 of file stl_iterator.h.

insert_iterator& operator++ | ( |  | ) | `[inline]`

| Simply returns *this. (This iterator does not "move".). Definition at line 545 of file stl_iterator.h.

insert_iterator& operator= | ( | const typename _Container::const_reference | __value | ) | `[inline]`

Parameters:

  | value | An instance of whatever type container_type::const_reference is; presumably a reference-to-const T for container<T>.

Returns:
  This iterator, for chained operations.

This kind of iterator maintains its own position in the container. Assigning a value to the iterator will insert the value into the container at the place before the iterator.

The position is maintained such that subsequent assignments will insert values immediately after one another. For example,

         // vector v contains A and Z

         insert_iterator i (v, ++v.begin());
         i = 1;
         i = 2;
         i = 3;

         // vector v contains A, 1, 2, 3, and Z

Definition at line 531 of file stl_iterator.h.

The documentation for this class was generated from the following file:

- stl_iterator.h